
#include "mainwidget.h"
//-------------------------------------------------------------------
MainWidget::MainWidget( QWidget *parent, const char *name ) : QWidget( parent, name)
{
	layout = new QVBoxLayout( this, 1, 1 );
	cmdgrp = new QHBoxLayout( layout );

	QDate nowDate = QDate::currentDate();
	QTime nowtime = QTime::currentTime();

	grp1 = new QGroupBox( this, "grp1" );
	grp1->setGeometry( QRect( 0, 0, 235, 125 ) ); 
	grp1->setTitle( tr( "start date" ) );

	grp2 = new QGroupBox( this, "grp2" );
	grp2->setGeometry( QRect( 0, 130, 231, 95 ) ); 
	grp2->setTitle( tr( "enable range" ) );

	TextLabel1 = new QLabel( grp1, "TextLabel1" );
	TextLabel1->setGeometry( QRect( 85, 20, 16, 20 ) ); 
	TextLabel1->setText( tr( "/" ) );

	TextLabel2 = new QLabel( grp1, "TextLabel2" );
	TextLabel2->setGeometry( QRect( 2, 90, 80, 21 ) ); 
	TextLabel2->setText( tr( "interval" ) );

	TextLabel3 = new QLabel( grp1, "TextLabel3" );
	TextLabel3->setGeometry( QRect( 160, 90, 70, 20 ) ); 
	TextLabel3->setText( tr( "minute" ) );

	TextLabel4 = new QLabel( grp2, "TextLabel4" );
	TextLabel4->setGeometry( QRect( 20, 60, 16, 21 ) ); 
	TextLabel4->setText( tr( "-" ) );

	TextLabel5 = new QLabel( grp1, "TextLabel5" );
	TextLabel5->setGeometry( QRect( 145, 20, 16, 20 ) ); 
	TextLabel5->setText( tr( "/" ) );

	TextLabel6 = new QLabel( grp1, "TextLabel6" );
	TextLabel6->setGeometry( QRect( 60, 55, 16, 20 ) ); 
	TextLabel6->setText( tr( ":" ) );

	TextLabel7 = new QLabel( grp2, "TextLabel7" );
	TextLabel7->setGeometry( QRect( 55, 25, 16, 20 ) ); 
	TextLabel7->setText( tr( ":" ) );

	TextLabel8 = new QLabel( grp2, "TextLabel8" );
	TextLabel8->setGeometry( QRect( 85, 60, 16, 20 ) ); 
	TextLabel8->setText( tr( ":" ) );

	year = new QSpinBox( grp1, "year" );
	year->setGeometry( QRect( 10, 20, 70, 25 ) ); 
	year->setFrameShape( QSpinBox::Box );
	year->setMidLineWidth( 0 );
	year->setMaxValue( 9999 );
	year->setMinValue( 1970 );
	year->setValue( nowDate.year() );
	year->setWrapping( true );

	month = new QSpinBox( grp1, "month" );
	month->setGeometry( QRect( 95, 20, 45, 25 ) ); 
	month->setFrameShape( QSpinBox::Box );
	month->setMidLineWidth( 0 );
	month->setMaxValue( 12 );
	month->setMinValue( 1 );
	month->setValue( nowDate.month() );
	month->setWrapping( true );

	day = new QSpinBox( grp1, "day" );
	day->setGeometry( QRect( 155, 20, 45, 25 ) ); 
	day->setFrameShape( QSpinBox::Box );
	day->setMidLineWidth( 0 );
	day->setMaxValue( 31 );
	day->setMinValue( 1 );
	day->setValue( nowDate.day() );
	day->setWrapping( true );

	hour = new QSpinBox( grp1, "hour" );
	hour->setGeometry( QRect( 10, 55, 45, 25 ) ); 
	hour->setFrameShape( QSpinBox::Box );
	hour->setMidLineWidth( 0 );
	hour->setMaxValue( 23 );
	hour->setMinValue( 0 );
	hour->setValue( nowtime.hour() );
	hour->setWrapping( true );

	minute = new QSpinBox( grp1, "minute" );
	minute->setGeometry( QRect( 70, 55, 45, 25 ) ); 
	minute->setFrameShape( QSpinBox::Box );
	minute->setMidLineWidth( 0 );
	minute->setMaxValue( 59 );
	minute->setMinValue( 0 );
	minute->setValue( nowtime.minute() );
	minute->setWrapping( true );

	interval = new QSpinBox( grp1, "interval" );
	interval->setGeometry( QRect( 85, 90, 65, 25 ) ); 
	interval->setFrameShape( QSpinBox::Box );
	interval->setMidLineWidth( 0 );
	interval->setMaxValue( 9999 );
	interval->setMinValue( 1 );
	interval->setValue( 10 );

	enaHour1 = new QSpinBox( grp2, "enaHour1" );
	enaHour1->setGeometry( QRect( 5, 25, 45, 25 ) ); 
	enaHour1->setFrameShape( QSpinBox::Box );
	enaHour1->setMidLineWidth( 0 );
	enaHour1->setMaxValue( 23 );
	enaHour1->setMinValue( 0 );
	enaHour1->setValue( 0 );
	enaHour1->setWrapping( true );

	enaMinute1 = new QSpinBox( grp2, "enaMinute1" );
	enaMinute1->setGeometry( QRect( 65, 25, 45, 25 ) ); 
	enaMinute1->setFrameShape( QSpinBox::Box );
	enaMinute1->setMidLineWidth( 0 );
	enaMinute1->setMaxValue( 59 );
	enaMinute1->setMinValue( 0 );
	enaMinute1->setValue( 0 );
	enaMinute1->setWrapping( true );

	enaHour2 = new QSpinBox( grp2, "enaHour2" );
	enaHour2->setGeometry( QRect( 35, 60, 45, 25 ) ); 
	enaHour2->setFrameShape( QSpinBox::Box );
	enaHour2->setMidLineWidth( 0 );
	enaHour2->setMaxValue( 23 );
	enaHour2->setMinValue( 0 );
	enaHour2->setValue( 0 );
	enaHour2->setWrapping( true );

	enaMinute2 = new QSpinBox( grp2, "enaMinute2" );
	enaMinute2->setGeometry( QRect( 95, 60, 45, 25 ) ); 
	enaMinute2->setFrameShape( QSpinBox::Box );
	enaMinute2->setMidLineWidth( 0 );
	enaMinute2->setMaxValue( 59 );
	enaMinute2->setMinValue( 0 );
	enaMinute2->setValue( 0 );
	enaMinute2->setWrapping( true );

	usercmd = new QCheckBox( this, "usercommand" );
	command = new QLineEdit( this, "command" );
	command->setEnabled( false );
	connect( usercmd, SIGNAL(toggled( bool )), SLOT(cmdToggled( bool )) );

	cmdgrp->addWidget(usercmd);
	cmdgrp->addWidget(command);

	disable = new QCheckBox( this, "disable" );
	disable->setGeometry( QRect( 0, 240, 200, 16 ) ); 
	disable->setText( tr( "auto receive stop" ) );

	apply = new QPushButton( this, "apply" );
	apply->setText( tr( "Apply" ) );

	connect( disable, SIGNAL(toggled( bool )), SLOT(stopToggled( bool )) );

	layout->addWidget(grp1);
	layout->addWidget(grp2);
//	layout->addWidget(command);
	layout->addWidget(disable);
	layout->addWidget(apply);
}
//-------------------------------------------------------------------
MainWidget::~MainWidget()
{
}
//-------------------------------------------------------------------
void MainWidget::stopToggled(bool on)
{
	year->setEnabled( !on );
	month->setEnabled( !on );
	day->setEnabled( !on );
	hour->setEnabled( !on );
	minute->setEnabled( !on );
	interval->setEnabled( !on );
	enaHour1->setEnabled( !on );
	enaMinute1->setEnabled( !on );
	enaHour2->setEnabled( !on );
	enaMinute2->setEnabled( !on );
}
//-------------------------------------------------------------------
void MainWidget::cmdToggled(bool on)
{
	command->setEnabled( on );
}
//-------------------------------------------------------------------
