#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

#define TIME_ZONE "Asia/Tokyo"
#define QT_PATH "/home/QtPalmtop/bin/"
#define TIMER "/var/spool/at"
#define PRODUCT "/proc/deviceinfo/product"
char commander[256] = "su zaurus -c ";

int deleteFile(char *command);
int fileCheck(char *file, char *command);

int main(int ac, char *av[])
{
	struct tm startTiming, enableTiming1, enableTiming2, nextTiming;
	time_t startTime, nextTime, enableTime1, enableTime2, now;
	char atfile[256];
	char temp[256], *tempp;
	int interval;
	FILE *f;

	//ѿꥢ
	memset(&startTiming, 0, sizeof(startTiming));
	memset(&enableTiming1, 0, sizeof(startTiming));
	memset(&enableTiming2, 0, sizeof(startTiming));
	memset(&nextTiming, 0, sizeof(startTiming));

	//ǥɤ߹
	if( (f = fopen(PRODUCT, "r")) == NULL )
	{
		fprintf(stderr, "cannot write [%s].\n", PRODUCT);
		exit(1);
	}
	fgets(temp, sizeof(temp), f);
	if( (tempp = strchr(temp, '\n')) != NULL )
	{
		*tempp = 0x0;
	}
	fclose(f);

	//A300ʤsuʤ
	fprintf(stderr, "Product: %s\n", temp);
	if( strcmp(temp, "SL-A300") == 0 )
	{
		commander[0] = 0x0;
	}

	//å
	if( ac < 2 )
	{
		//ʤ
		fprintf(stderr, "useage: qat startdate interval(minute) command [enabletime]\n");
		fprintf(stderr, "useage: qat -d command\n");
		exit(1);
	}
	if( ac == 3 && strcmp(av[1], "-d") == 0)
	{
		//ͽץ󤬻ꤵ줿
		if( deleteFile(av[2]) != 0 )
		{
			exit(1);
		}
		exit(0);
	}
	if( ac < 4 )
	{
		fprintf(stderr, "useage: qat startdate interval(minute) command [enabletime]\n");
		exit(1);
	}

	//եեޥåȥå
	if( !strptime(av[1], "%Y/%m/%d-%H:%M", &startTiming) )
	{
		//եޥå
		fprintf(stderr, "date-format error.\nmust be [yyyy/mm/dd-hh:mm:ss]\n");
		exit(1);
	}

	//դ¤Τ
	startTime = mktime(&startTiming);
	fprintf(stderr, "command time [%04d/%02d/%02d-%02d:%02d].\n",
		1900+startTiming.tm_year, startTiming.tm_mon+1, startTiming.tm_mday, startTiming.tm_hour, startTiming.tm_min);

	//ֳֿͥå
	interval = atoi(av[2]);
	if( interval <= 0 )
	{
		fprintf(stderr, "invalid interval.\n");
		exit(1);
	}

	//դʤ鸽ߤ
	time(&now);
	if( startTime < now)
	{
		startTime = now;
	}
	//λ֤򻻽
	nextTime = startTime + interval * 60;
	nextTiming = *localtime(&nextTime);

	if( ac > 4 )
	{
		//ͭϰϤλꤢ

		//ͭϰϤΡʬˤϳդΤΤ
		enableTiming1 = enableTiming2 = *localtime(&startTime);

		//ϰϥեޥåȥå
		strcpy(temp, av[4]);
		if( strlen(temp) != 11 )
		{
			//եޥå
			fprintf(stderr, "enable-time-format error.\nmust be [hh:mm-hh:mm]\n");
			exit(1);
		}
		tempp = &(temp[6]);
		temp[5] = 0x0;
		if( !strptime(temp, "%H:%M", &enableTiming1) || !strptime(tempp, "%H:%M", &enableTiming2) )
		{
			//֥եޥå
			fprintf(stderr, "enable-time-format error.\nmust be [hh:mm]\n");
			exit(1);
		}
		enableTime1 = mktime(&enableTiming1);
		enableTime2 = mktime(&enableTiming2);

		if( enableTime1 == enableTime2 )
		{
			//ϤȽλƱʤΤϰϻϻѤʤ
		}else
		{
			if( enableTime1 > enableTime2 )
			{
				//ޤ
				enableTime2 += 24*60*60;
				enableTiming2 = *localtime(&enableTime2);
			}

			if( enableTime1 < now && enableTime2 < now)
			{
				enableTime1 += 24*60*60;
				enableTiming1 = *localtime(&enableTime1);
				enableTime2 += 24*60*60;
				enableTiming2 = *localtime(&enableTime2);
			}

			sprintf(temp, "next enable time [%04d/%02d/%02d-%02d:%02d]-[%04d/%02d/%02d-%02d:%02d].",
				1900+enableTiming1.tm_year, enableTiming1.tm_mon+1, enableTiming1.tm_mday, enableTiming1.tm_hour, enableTiming1.tm_min,
				1900+enableTiming2.tm_year, enableTiming2.tm_mon+1, enableTiming2.tm_mday, enableTiming2.tm_hour, enableTiming2.tm_min);
			fprintf(stderr, "%s\n", temp);

			if( enableTime1 <= startTime && startTime <= enableTime2 )
			{
				//ϻ֤ϰʤʤ
			}else
			if( startTime < enableTime1 )
			{
				//ϻ֤ϰϤʤ
				startTime = enableTime1;
			}else
			if( startTime > enableTime2 )
			{
				//ϻ֤ϰϤʤ
				startTime = enableTime1 + 24*60*60;
			}

			//դƷ׻
			nextTime = startTime + interval * 60;
			nextTiming = *localtime(&nextTime);

			if( enableTime1 <= nextTime && nextTime <= enableTime2 )
			{
				//֤ϰʤʤ
			}else
			if( nextTime < enableTime1 )
			{
				//֤ϰϤʤ
				nextTime = enableTime1;
			}else
			if( nextTime > enableTime2 )
			{
				//֤ϰϤʤ
				nextTime = enableTime1 + 24*60*60;
			}
		}
	}
	//ե̾
	sprintf(atfile, "%s/%ld.333", TIMER, startTime);

	//ϻ֤֡γ
	startTiming = *localtime(&startTime);
	nextTiming = *localtime(&nextTime);
	sprintf(temp, "%04d/%02d/%02d-%02d:%02d",
		1900+startTiming.tm_year, startTiming.tm_mon+1, startTiming.tm_mday, startTiming.tm_hour, startTiming.tm_min);
	fprintf(stderr, "start timing [%s].\n", temp);

	sprintf(temp, "%04d/%02d/%02d-%02d:%02d",
		1900+nextTiming.tm_year, nextTiming.tm_mon+1, nextTiming.tm_mday, nextTiming.tm_hour, nextTiming.tm_min);
	fprintf(stderr, "next timing [%s].\n", temp);

	//shellν񤭽Ф
	if( (f = fopen(atfile, "w")) == NULL )
	{
		fprintf(stderr, "cannot write [%s].\n", atfile);
		exit(1);
	}

	fprintf(f, "#!/bin/sh\n");
	if( ac > 4 )
	{
		fprintf(f, "#qat %s %s \"%s\" %s\n", av[1], av[2], av[3], av[4]);
	}else
	{
		fprintf(f, "#qat %s %s \"%s\"\n", av[1], av[2], av[3]);
	}
	fprintf(f, "rm $0\n");
	if( commander[0] == 0x0 )
	{
		fprintf(f, "%s\n", av[3]);
	}else
	{
		fprintf(f, "%s\"%s\"\n", commander, av[3]);
	}
	fprintf(f, "export TZ=%s\n", TIME_ZONE);
	if( ac > 4 )
	{
		fprintf(f, "%sqat %s %s \"%s\" %s\n", QT_PATH, temp, av[2], av[3], av[4]);
	}else
	{
		fprintf(f, "%sqat %s %s \"%s\"\n", QT_PATH, temp, av[2], av[3]);
	}
	fclose(f);

	//¹ԸͿ
	if( chmod(atfile, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH) != 0 )
	{
		fprintf(stderr, "cannot write [%s].\n", atfile);
		exit(1);
	}
	fprintf(stderr,"%s add OK.\n", atfile);

	exit(0);

}
int deleteFile(char *command)
{
	DIR *dp;
	struct dirent *entry;
	char file[256];
	int ret;

	ret = 1;
	if(( dp = opendir(TIMER) ) == NULL )
	{
		fprintf(stderr, "dir open error.\n");
		return ret;
	}

	while((entry = readdir(dp)) != NULL)
	{
		if( strstr(entry->d_name, ".333") )
		{
			sprintf(file, "%s/%s", TIMER, entry->d_name);
			if( fileCheck(file, command) )
			{
				unlink(file);
				fprintf(stderr, "delete file [%s].\n", file);
				ret = 0;
			}
		}
	}

	closedir(dp);
	return ret;
}
int fileCheck(char *file, char *command)
{
	FILE *f;
	int cnt, ret;
	char buf[256], cmp[256];

	if( (f = fopen(file, "r")) == NULL)
	{
		return 0;
	}
	cnt = 0;
	ret = 0;
	if( commander[0] == 0x0 )
	{
		sprintf(cmp, "%s\n", command);
	}else
	{
		sprintf(cmp, "%s\"%s\"\n", commander, command);
	}
	while( fgets(buf, sizeof(buf), f) != 0 )
	{
		cnt++;
		if( strcmp(buf, cmp) == 0 && cnt == 4 )
		{
			ret = 1;
			break;
		}
	}
	fclose(f);
	return ret;
}
